import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["leftAddon", "rightAddon"];
import PropTypes from 'prop-types';
import cx from 'classnames';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var BASE_CLASS = 'sui-AtomInput-addon';
var CLASS_ADDON_WRAPPER = 'sui-AtomInput-addonWrapper';
var TYPES = {
  LEFT: 'left',
  RIGHT: 'right'
};

var getClassName = function getClassName(_ref) {
  var type = _ref.type;
  return cx(BASE_CLASS, BASE_CLASS + "--" + type);
};

var withAddons = function withAddons(WrappedInput) {
  var Addon = function Addon(_ref2) {
    var leftAddon = _ref2.leftAddon,
        rightAddon = _ref2.rightAddon,
        props = _objectWithoutPropertiesLoose(_ref2, _excluded);

    return leftAddon || rightAddon ? /*#__PURE__*/_jsxs("div", {
      className: CLASS_ADDON_WRAPPER,
      children: [leftAddon && /*#__PURE__*/_jsx("span", {
        className: getClassName({
          type: TYPES.LEFT
        }),
        children: leftAddon
      }), /*#__PURE__*/_jsx(WrappedInput, _extends({}, props)), rightAddon && /*#__PURE__*/_jsx("span", {
        className: getClassName({
          type: TYPES.RIGHT
        }),
        children: rightAddon
      })]
    }) : /*#__PURE__*/_jsx(WrappedInput, _extends({}, props));
  };

  return Addon;
};

export default withAddons;