import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["type"];
import PropTypes from 'prop-types';
import Input, { inputSizes, inputStates } from './Input';
import Password from './Password';
import Mask from './Mask';
import { jsx as _jsx } from "react/jsx-runtime";
var TYPES = {
  DATE: 'date',
  MASK: 'mask',
  NUMBER: 'number',
  PASSWORD: 'password',
  SUI_PASSWORD: 'sui-password',
  TEXT: 'text',
  TEL: 'tel',
  EMAIL: 'email'
};

var AtomInput = function AtomInput(_ref) {
  var type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  switch (type) {
    case 'sui-password':
      return /*#__PURE__*/_jsx(Password, _extends({}, props));

    case 'mask':
      return /*#__PURE__*/_jsx(Mask, _extends({}, props));

    default:
      return /*#__PURE__*/_jsx(Input, _extends({}, props, {
        type: type
      }));
  }
};

AtomInput.displayName = 'AtomInput';
export default AtomInput;
export { inputSizes, inputStates, TYPES as inputTypes };